#pragma warning disable 1591
using System;
using System.Data;
using System.Linq;
using System.Linq.Expressions;
using System.Data.Common;
using System.Collections.Generic;
using Telerik.OpenAccess;
using Telerik.OpenAccess.Metadata;
using Telerik.OpenAccess.Data.Common;
using Telerik.OpenAccess.Metadata.Fluent;
using Telerik.OpenAccess.Metadata.Fluent.Advanced;
using DataAccessModel1;
using Telerik.OpenAccess.Metadata.Relational;

namespace DataAccessModel1
{

	public partial class FluentModelFluentMetadataSource : FluentMetadataSource
	{
		
		protected override IList<MappingConfiguration> PrepareMapping()
		{
			List<MappingConfiguration> mappingConfigurations = new List<MappingConfiguration>();
			
			MappingConfiguration<Address> addressConfiguration = this.GetAddressMappingConfiguration();
			mappingConfigurations.Add(addressConfiguration);
			
			MappingConfiguration<CustomerAddress> customeraddressConfiguration = this.GetCustomerAddressMappingConfiguration();
			mappingConfigurations.Add(customeraddressConfiguration);
			
			MappingConfiguration<SupplierAddress> supplieraddressConfiguration = this.GetSupplierAddressMappingConfiguration();
			mappingConfigurations.Add(supplieraddressConfiguration);
			
			MappingConfiguration<Customer> customerConfiguration = this.GetCustomerMappingConfiguration();
			mappingConfigurations.Add(customerConfiguration);
			
			MappingConfiguration<Supplier> supplierConfiguration = this.GetSupplierMappingConfiguration();
			mappingConfigurations.Add(supplierConfiguration);
			
			return mappingConfigurations;
		}
		
		protected override void SetContainerSettings(MetadataContainer container)
		{
			container.Name = "EntitiesModel";
			container.DefaultNamespace = "DataAccessModel1";
			container.NameGenerator.RemoveLeadingUnderscores = false;
			container.NameGenerator.SourceStrategy = Telerik.OpenAccess.Metadata.NamingSourceStrategy.Property;
			container.NameGenerator.RemoveCamelCase = false;
		}
		public MappingConfiguration<Address> GetAddressMappingConfiguration()
		{
			MappingConfiguration<Address> configuration = this.GetAddressClassConfiguration();
			this.PrepareAddressPropertyConfigurations(configuration);

			return configuration;
		}

		public MappingConfiguration<Address> GetAddressClassConfiguration()
		{
			MappingConfiguration<Address> configuration = new MappingConfiguration<Address>();
			configuration.MapType(x => new { }).Inheritance(InheritanceStrategy.Default).HasDiscriminatorValue("1").ToTable("Addresses");
	
			return configuration;
		}
	
		public void PrepareAddressPropertyConfigurations(MappingConfiguration<Address> configuration)
		{
			configuration.HasProperty(x => x.AddressId).IsIdentity(KeyGenerator.Autoinc).HasFieldName("_addressId").ToColumn("AddressId").IsNotNullable().HasColumnType("int").HasPrecision(0).HasScale(0).WithConverter("OpenAccessRuntime.Data.IntConverter");
			configuration.HasProperty(x => x.Country).HasFieldName("_country").ToColumn("Country").IsNullable().HasColumnType("varchar").HasLength(255).WithConverter("OpenAccessRuntime.Data.VariableLengthAnsiStringConverter");
			configuration.HasProperty(x => x.City).HasFieldName("_city").ToColumn("City").IsNullable().HasColumnType("varchar").HasLength(255).WithConverter("OpenAccessRuntime.Data.VariableLengthAnsiStringConverter");
			configuration.HasProperty(x => x.StreetName).HasFieldName("_streetName").ToColumn("StreetName").IsNullable().HasColumnType("varchar").HasLength(255).WithConverter("OpenAccessRuntime.Data.VariableLengthAnsiStringConverter");
			configuration.HasProperty(x => x.ZipCode).HasFieldName("_zipCode").ToColumn("ZipCode").IsNullable().HasColumnType("varchar").HasLength(255).WithConverter("OpenAccessRuntime.Data.VariableLengthAnsiStringConverter");
			configuration.HasProperty(x => x.StreetNumber).HasFieldName("_streetNumber").ToColumn("StreetNumber").IsNullable().HasColumnType("varchar").HasLength(255).WithConverter("OpenAccessRuntime.Data.VariableLengthAnsiStringConverter");
		}
		public MappingConfiguration<CustomerAddress> GetCustomerAddressMappingConfiguration()
		{
			MappingConfiguration<CustomerAddress> configuration = this.GetCustomerAddressClassConfiguration();
			this.PrepareCustomerAddressPropertyConfigurations(configuration);
			this.PrepareCustomerAddressAssociationConfigurations(configuration);

			return configuration;
		}

		public MappingConfiguration<CustomerAddress> GetCustomerAddressClassConfiguration()
		{
			MappingConfiguration<CustomerAddress> configuration = new MappingConfiguration<CustomerAddress>();
			configuration.MapType(x => new { }).Inheritance(InheritanceStrategy.Flat).HasDiscriminatorValue("2").ToTable("Addresses");
	
			return configuration;
		}
	
		public void PrepareCustomerAddressPropertyConfigurations(MappingConfiguration<CustomerAddress> configuration)
		{
			configuration.HasProperty(x => x.CustomerId).HasFieldName("_customerId").ToColumn("CustomerId").IsNullable().HasColumnType("int").HasPrecision(0).HasScale(0).WithConverter("OpenAccessRuntime.Data.IntConverter");
		}
	
		public void PrepareCustomerAddressAssociationConfigurations(MappingConfiguration<CustomerAddress> configuration)
		{
			configuration.HasAssociation(x => x.Customer).HasFieldName("_customer").WithOpposite(x => x.CustomerAddresses).ToColumn("CustomerId").WithDataAccessKind(DataAccessKind.ReadWrite);
		}
		
		public MappingConfiguration<SupplierAddress> GetSupplierAddressMappingConfiguration()
		{
			MappingConfiguration<SupplierAddress> configuration = this.GetSupplierAddressClassConfiguration();
			this.PrepareSupplierAddressPropertyConfigurations(configuration);
			this.PrepareSupplierAddressAssociationConfigurations(configuration);

			return configuration;
		}

		public MappingConfiguration<SupplierAddress> GetSupplierAddressClassConfiguration()
		{
			MappingConfiguration<SupplierAddress> configuration = new MappingConfiguration<SupplierAddress>();
			configuration.MapType(x => new { }).Inheritance(InheritanceStrategy.Flat).HasDiscriminatorValue("3").ToTable("Addresses");
	
			return configuration;
		}
	
		public void PrepareSupplierAddressPropertyConfigurations(MappingConfiguration<SupplierAddress> configuration)
		{
			configuration.HasProperty(x => x.SupplierId).HasFieldName("_supplierId").ToColumn("SupplierId").IsNullable().HasColumnType("int").HasPrecision(0).HasScale(0).WithConverter("OpenAccessRuntime.Data.IntConverter");
		}
	
		public void PrepareSupplierAddressAssociationConfigurations(MappingConfiguration<SupplierAddress> configuration)
		{
			configuration.HasAssociation(x => x.Supplier).HasFieldName("_supplier").WithOpposite(x => x.SupplierAddresses).ToColumn("SupplierId").WithDataAccessKind(DataAccessKind.ReadWrite);
		}
		
		public MappingConfiguration<Customer> GetCustomerMappingConfiguration()
		{
			MappingConfiguration<Customer> configuration = this.GetCustomerClassConfiguration();
			this.PrepareCustomerPropertyConfigurations(configuration);
			this.PrepareCustomerAssociationConfigurations(configuration);

			return configuration;
		}

		public MappingConfiguration<Customer> GetCustomerClassConfiguration()
		{
			MappingConfiguration<Customer> configuration = new MappingConfiguration<Customer>();
			configuration.MapType(x => new { }).ToTable("Customers");
	
			return configuration;
		}
	
		public void PrepareCustomerPropertyConfigurations(MappingConfiguration<Customer> configuration)
		{
			configuration.HasProperty(x => x.CustomerId).IsIdentity(KeyGenerator.Autoinc).HasFieldName("_customerId").ToColumn("CustomerId").IsNotNullable().HasColumnType("int").HasPrecision(0).HasScale(0).WithConverter("OpenAccessRuntime.Data.IntConverter");
			configuration.HasProperty(x => x.CustomerName).HasFieldName("_customerName").ToColumn("CustomerName").IsNullable().HasColumnType("varchar").HasLength(255).WithConverter("OpenAccessRuntime.Data.VariableLengthAnsiStringConverter");
		}
	
		public void PrepareCustomerAssociationConfigurations(MappingConfiguration<Customer> configuration)
		{
			configuration.HasAssociation(x => x.CustomerAddresses).HasFieldName("_customerAddresses").WithOpposite(x => x.Customer).ToColumn("CustomerId").WithDataAccessKind(DataAccessKind.ReadWrite);
		}
		
		public MappingConfiguration<Supplier> GetSupplierMappingConfiguration()
		{
			MappingConfiguration<Supplier> configuration = this.GetSupplierClassConfiguration();
			this.PrepareSupplierPropertyConfigurations(configuration);
			this.PrepareSupplierAssociationConfigurations(configuration);

			return configuration;
		}

		public MappingConfiguration<Supplier> GetSupplierClassConfiguration()
		{
			MappingConfiguration<Supplier> configuration = new MappingConfiguration<Supplier>();
			configuration.MapType(x => new { }).ToTable("Suppliers");
	
			return configuration;
		}
	
		public void PrepareSupplierPropertyConfigurations(MappingConfiguration<Supplier> configuration)
		{
			configuration.HasProperty(x => x.SupplierId).IsIdentity(KeyGenerator.Autoinc).HasFieldName("_supplierId").ToColumn("SupplierId").IsNotNullable().HasColumnType("int").HasPrecision(0).HasScale(0).WithConverter("OpenAccessRuntime.Data.IntConverter");
			configuration.HasProperty(x => x.SupplierName).HasFieldName("_supplierName").ToColumn("SupplierName").IsNullable().HasColumnType("varchar").HasLength(255).WithConverter("OpenAccessRuntime.Data.VariableLengthAnsiStringConverter");
		}
	
		public void PrepareSupplierAssociationConfigurations(MappingConfiguration<Supplier> configuration)
		{
			configuration.HasAssociation(x => x.SupplierAddresses).HasFieldName("_supplierAddresses").WithOpposite(x => x.Supplier).ToColumn("SupplierId").WithDataAccessKind(DataAccessKind.ReadWrite);
		}
		
	}
}
#pragma warning restore 1591
